uint w;
uint h;

struct VertexIn
{
  float4 Position : SV_Position;
  float4 ScreenPosition : TEXCOORD0;
};

Texture2D colorTexture;
Texture2D depthTexture;

RWStructuredBuffer<uint> packBuffer;

float4 main(VertexIn In, float4 ScreenPos : SV_Position) : SV_Target
{
  const float4 color = colorTexture.Load(int3(ScreenPos.xy, 0));
  const float depth = depthTexture.Load(int3(ScreenPos.xy, 0)).r;

  uint2 p = uint2(ScreenPos.xy);
  if (p.x < w && p.y < h) {
    float4 val = saturate(color);
#ifndef CAPTURE_LINEAR
    val.rgb = pow(val.rgb, 1.0/2.2);
#endif

    packBuffer[p.y*w + p.x] =
      (uint(255.0*val.a) << 24) |
      (uint(255.0*val.b) << 16) |
      (uint(255.0*val.g) << 8) |
      (uint(255.0*val.r) << 0);
  }

  return float4(color.rgb, 1);
}
