VertexOut vertexFunctionGS(VertexIn input)
{
  VertexOut output = (VertexOut)0;

  output.Position = mul(mul(float4(input.Position.xyz, 1.0), worldMatrix), worldToClipMatrix);

  return output;
}

#ifndef VERTEX_FUNCTION
VertexOut vertexFunction(VertexIn input)
{
  VertexOut output = (VertexOut)0;

  float4 cp = mul(mul(float4(input.Position.xyz, 1.0), worldMatrix), worldToClipMatrix);
  float3 p = (1.0 / cp.w) * cp.xyz;

  output.texCoord = pointSizes.x * (float2(input.Position.w < 0.0 ? 1 : 0, abs(input.Position.w) < 2.f ? 1 : 0) - float2(0.5, 0.5));

  p.xy = floor(viewportScale.xy * p.xy) + float2(0.5, 0.5) + output.texCoord;

  output.Position = float4(viewportScale.zw * p.xy, p.z, 1.0);
  
  return output;
}
#endif