#include "BlueNoise.hlsl"

float W;
float lightScale;

float3 ToneMap_FilmicUncharted2(float3 v)
{
  float A = 0.15; // Shoulder strength
  float B = 0.50; // Linear strength
  float C = 0.10; // Linear angle
  float D = 0.20; // Toe strength
  float E = 0.02; // Toe numerator
  float F = 0.30; // Toe denominator

  return ((v*(A*v + C*B) + D*E) / (v*(A*v + B) + D*F)) - E / F;
}

Texture2D colorTexture;

RWStructuredBuffer<float>  exposureBuffer;

float4 main(float4 ScreenPos : SV_Position) : SV_Target
{
  float4 color = colorTexture.Load(int3(ScreenPos.xy, 0));
  float exposure = exposureBuffer[0]; // log-average: 1/N exp(sum log(epsilon + luminance))

  color.rgb = ToneMap_FilmicUncharted2(exposure * lightScale * color.rgb);

  float whiteScale = 1.0 / ToneMap_FilmicUncharted2((float3)W).r;
  color.rgb *= whiteScale;

  float3 dither = (blueNoise3(int2(ScreenPos.xy))*2.0-1.0)*(1.0/255);
  color.rgb += dither;

  return float4(color.rgb, 1.0);
}
