
VertexOut vertexFunction(VertexIn In)
{
  VertexOut Out = (VertexOut)0;

#if defined (COGS_SPRITES_VIEWTRANSFORM)
  Out.WorldPosition = mul(In.Position, worldMatrix);
  Out.Position = mul(Out.WorldPosition, worldToClipMatrix);
#elif defined (COGS_SPRITES_PIXELTRANSFORM)
  float2 viewportScale = 1.0 / viewportSize;
  float2 scaled = In.Position.xy * viewportScale;
  float2 ndc = float2(scaled.x, scaled.y) * 2.0f - float2(1, 1);
#ifdef COGS_REVERSE_DEPTH
  In.Position.z = -In.Position.z;
#endif
  Out.Position = float4(ndc, In.Position.z*0.5+0.5, 1);
#else
#ifdef COGS_REVERSE_DEPTH
  In.Position.z = -In.Position.z;
#endif
  Out.Position = mul(float4(In.Position.xy, In.Position.z*0.5+0.5, 1), worldMatrix);
#endif

  Out.Parameters = In.Normal;
  Out.TexCoord.xz = imageFlip.x * (1 - In.TexCoord.xz) + (1 - imageFlip.x) * In.TexCoord.xz;
  Out.TexCoord.yw = imageFlip.y * (1 - In.TexCoord.yw) + (1 - imageFlip.y) * In.TexCoord.yw;

  return Out;
}
